<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="m-4">

  <div
    id="secureMailListTitle"
    class="h3"
    [innerText]="messages.MAIL_SEC_TITLE">
  </div>

  <!-- Header -->

  <div class="pt-3 d-flex">

    <form class="d-flex flex-row align-items-start">

      <button
        ls-button
        (click)="onCreateButtonClicked()"
        [icon]="commonIcons.CREATE_ICON"
        [text]="messages.CONNECTOR_CREATE"
        [disabled]="!tenantId">
      </button>

    </form>

    <span class="flex-grow-1"></span>
    <span class="p-1 px-2" [innerText]="commonMessages.PAGINATION_SIZE_LABEL"></span>

    <ngb-pagination
      size="sm"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="requestSecureMailServerList()">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>

  </div>

  <!-- List -->

  <table
    aria-labelledby="secureMailListTitle"
    class="bg-white mt-2 table table-striped table-borderless border shadow-sm table-fixed table-text-overflow">

    <thead class="border">
      <tr>
        <th
          scope="col"
          *ngIf="userPreferences.showAdminIds"
          class="th-sm col-secure-mail-id-fixed-size"
          [innerText]="commonMessages.ID">
        </th>
        <th
          scope="col"
          [innerText]="commonMessages.NAME">
        </th>
        <th
          scope="col"
          [innerText]="messages.URL">
        </th>
        <th
          scope="col"
          [innerText]="messages.LOGIN">
        </th>
        <th
          scope="col"
          class="col-buttons-fixed-size"
          [innerText]="commonMessages.ACTIONS">
        </th>
      </tr>
    </thead>
    <tbody
      app-list-loader
      [data]="serverList"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_CONNECTOR_LIST"
      [loading]="loading">
    </tbody>
    <tbody>
      <tr *ngFor="let server of serverList">
        <td
          *ngIf="userPreferences.showAdminIds"
          [innerText]="server.id">
        </td>
        <td [innerText]="server.name"></td>
        <td [innerText]="server.url"></td>
        <td>
          <span
            class="font-monospace text-size-small"
            [innerText]="server.login">
          </span>
        </td>
        <td class="d-flex">
          <button
            ls-button
            [style]="style.NORMAL"
            [icon]="commonIcons.EDIT_ICON"
            (click)="onEditButtonClicked(server)">
          </button>
          <button
            ls-button
            class="ms-2"
            [style]="style.DANGER"
            [icon]="commonIcons.DELETE_ICON"
            (click)="onDeleteButtonClicked(server)">
          </button>
        </td>
      </tr>
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="requestSecureMailServerList()">
  </ngb-pagination>

</div>
